#!/bin/bash

#clear

if [ -z "`find . -maxdepth 1 -type f -iname "*.domin"`" ]
then
    echo "No *.domin files"
    exit
fi


PATH=$PATH:.

export MallocGuardEdges=1
export MallocScribble=1
export MallocCheckHeapStart=1
export MallocCheckHeapEach=1
#export MallocLogFile=Malloc.log
#export MallocStackLoggingNoCompact=1
#export MallocStackLoggingDirectory=.
#export MallocHelp=1

exec 6>&1 # Store sdtout

for i in {1..1}; do

   exec 1>>"$MACHTYPE.log" #stdout
   exec 2>>"$MACHTYPE.log" #errout

   for FullName in *.domin; 
   do

      Name=$(basename "$FullName")

      if [ "$Name" != "DominFramework.domin" ]; 
      then

         printf "Run unit test for \"$FullName\"\n\n">&6 #console output

         printf "\n\n\n//**********************************\n"
         printf "Run unit test for \"$FullName\"\n"
         printf "//**********************************\n"   

         #
         printf "\n\n*** Compile *** \"$Name\"\n"
         #

         printf "\n\ndomincompiler \"$Name\"\n"
         domincompiler -noshowtime -noshowver "$Name"
         
         printf "\n\ndomincompiler -writedebug \"$Name\"\n"
         domincompiler -noshowtime -noshowver -writedebug "$Name"
         
         printf "\n\ndomincompiler -writedisasm \"$Name\"\n"
         domincompiler -noshowtime -noshowver -writedisasm "$Name"
         
         #
         printf "\n\n*** Compile & run *** \"$Name\"\n"
         #
         
         printf "\n\ndomincompiler \"${Name%.*}.vm\"\n"
         domincompiler -noshowtime -noshowver "${Name%.*}.vm"

         printf "\n\ndomincompiler -run \"$Name\"\n"
         domincompiler -noshowtime -noshowver -run "$Name"
         
         printf "\n\ndomincompiler -writedebug -run \"$Name\"\n"
         domincompiler -noshowtime -noshowver -writedebug -run "$Name"
         
         printf "\n\ndomincompiler -writedisasm -run \"$Name\"\n"
         domincompiler -noshowtime -noshowver -writedisasm -run "$Name"
         
         printf "\n\ndomincompiler -writedebug -writedisasm -run \"$Name\"\n"
         domincompiler -noshowtime -noshowver -writedebug -writedisasm -run "$Name"

      fi
   done
done

#------------------------------------------------------------------
